<?php
/*------------------------------------------------------------------------
# product.php - Product advisor Component
# ------------------------------------------------------------------------
# author    Matthias Drobny, drobny.iT
# copyright Copyright (C) 2014. All Rights Reserved
# license   GNU/GPL Version 2 or later - http://www.gnu.org/licenses/gpl-2.0.html
# website   www.drobny.it
-------------------------------------------------------------------------*/

// No direct access to this file
defined('_JEXEC') or die('Restricted access');
// import Joomla modelitem library
jimport('joomla.application.component.modelitem');

/**
 * Product Model for Productadvisor Component
 */
class ProductadvisorModelProduct extends JModelItem
{
	/**
	 * Model context string.
	 *
	 * @var		string
	 */
	protected $_context = 'com_productadvisor.product';

	/**
	 * Method to auto-populate the model state.
	 *
	 * Note. Calling getState in this method will result in recursion.
	 *
	 * @since	1.6
	 */
	protected function populateState()
	{
		$app = JFactory::getApplication('site');

		// Load state from the request.
		$pk = JRequest::getInt('product_id');
		$this->setState('product.product_id', $pk);
		// Load the parameters.
		$params = $app->getParams();
		$this->setState('params', $params);
	}

	/**
	 * Method to get Product data.
	 *
	 * @param	integer	The id of the Product.
	 *
	 * @return	mixed	Menu item data object on success, false on failure.
	 */
	public function &getItem($pk = null)
	{
		// Initialise variables.
		$pk = (!empty($pk)) ? $pk : (int) $this->getState('product.product_id');
		if ($this->_item === null) {
			$this->_item = array();
		}
		if (!isset($this->_item[$pk])) {
			try {
				$db = $this->getDbo();
				$query = $db->getQuery(true);
				$query->select('*');
				$query->from('#__productadvisor_products');
				$query->where('product_id = "'.$pk.'"');
				$db->setQuery($query);
				$data = $db->loadObject();
// print_r($data);
				$this->_item[$pk] = $data;
			}
			catch (JException $e)
			{
				if ($e->getCode() == 404) {
					// Need to go thru the error handler to allow Redirect to work.
					JError::raiseError(404, $e->getMessage());
				} else {
					$this->setError($e);
					$this->_item[$pk] = false;
				}
			}
		}

		return $this->_item[$pk];
	}
	
	public function getAttributes($item) {
// 		print_r($this);
// 		print_r($item);
		$db = $this->getDbo();
		$query = $db->getQuery(true);
		$query->select('pa.productattribute_id, pa.attribute_catid, pa.attribute_value, c.id, c.title, c.alias');
		$query->from('#__productadvisor_products AS p');
		$query->join('inner', '#__productadvisor_productattributes AS pa ON p.product_id = pa.product_id');
		$query->join('inner', '#__categories AS c ON pa.attribute_catid = c.id');
		$query->where('p.product_id = "'.$item->product_id.'"');
		$query->order('pa.attribute_value ASC');
		$db->setQuery($query);
		$data = $db->loadObjectList();

// $attr = $this->getUserStateFromRequest($this->context.'.filter.'.$a->alias, 'filter_'.$a->alias, '', 'string');
// print_r($attr);
		
/*
SELECT pa.productattribute_id, pa.product_id, pa.attribute_catid, pa.attribute_value, c.id, c.title, c.alias, p.name, p.description, p.shop_url
FROM `j25_productadvisor_products` AS p
INNER JOIN j25_productadvisor_productattributes AS pa ON p.product_id = pa.product_id
INNER JOIN j25_categories AS c ON pa.attribute_catid = c.id
*/

		$attributes = array();
		foreach($data as $a) {
			if(!array_key_exists($a->attribute_catid, $attributes) ) {//!is_array($attributes[$a->attribute_catid])
				$attributes[$a->attribute_catid] = array(
					'values'	=>	array(),
					'alias'		=>	$a->alias,
					'title'		=>	$a->title,
					'catid'		=>	$a->id
				);
			}
			$attributes[$a->attribute_catid]['values'][] = $a->attribute_value;
		}
// 		$item->attributes = $attributes;
// 		echo "<pre>";
// 		print_r($allAttributes);
// 		echo "</pre>";
		return $attributes;
	}
}
?>